﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

// alpha color, timer, double buffering
namespace AlphaColor
{
	public partial class Form1 : Form
	{
		int alpha = 100;
        bool forward = false;

		public Form1()
		{
			InitializeComponent();

            SetStyle(ControlStyles.AllPaintingInWmPaint, true);
            SetStyle(ControlStyles.DoubleBuffer, true);
            SetStyle(ControlStyles.UserPaint, true);
		}

		private void Form1_Paint(object sender, PaintEventArgs e)
		{
            e.Graphics.FillEllipse(Brushes.Blue, 20, 20, 180, 150);
			SolidBrush b = new SolidBrush(Color.FromArgb(alpha, 255, 0, 0));
			e.Graphics.FillRectangle(b, 100, 100, 180, 150);

            string str = "Alpha=" + alpha.ToString();
            Font f = new Font("맑은 고딕", 12);
            StringFormat sf = new StringFormat(StringFormatFlags.DirectionVertical);
            e.Graphics.DrawString(str, f, Brushes.Black, 10, 10, sf);
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (forward)
                alpha -= 20;
            else
                alpha += 20;
            if (alpha <= 100 || alpha >= 240)
                forward = !forward;

            Invalidate();
        }
	}
}
